package com.zt.plat.module.qms.business.config.dal.mapper;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectParameterPageReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectParameterDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;

/**
 * 检测方法分析项目参数配置 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface ConfigAssayMethodProjectParameterMapper extends BaseMapperX<ConfigAssayMethodProjectParameterDO> {

    default PageResult<ConfigAssayMethodProjectParameterDO> selectPage(ConfigAssayMethodProjectParameterPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigAssayMethodProjectParameterDO>()
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getConfigAssayMethodProjectId, reqVO.getConfigAssayMethodProjectId())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getDictionaryParameterId, reqVO.getDictionaryParameterId())
                .likeIfPresent(ConfigAssayMethodProjectParameterDO::getParameterName, reqVO.getParameterName())
                .likeIfPresent(ConfigAssayMethodProjectParameterDO::getShortName, reqVO.getShortName())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getNo, reqVO.getNo())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getKey, reqVO.getKey())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getUnitId, reqVO.getUnitId())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getUnit, reqVO.getUnit())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getFillingWay, reqVO.getFillingWay())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getDataType, reqVO.getDataType())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getDefaultValue, reqVO.getDefaultValue())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getIsNull, reqVO.getIsNull())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getFormula, reqVO.getFormula())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getIsShow, reqVO.getIsShow())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getSortNo, reqVO.getSortNo())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigAssayMethodProjectParameterDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ConfigAssayMethodProjectParameterDO::getVersion, reqVO.getVersion())
                .orderByDesc(ConfigAssayMethodProjectParameterDO::getId));
    }
    
    default List<ConfigAssayMethodProjectParameterDO> selectByConfigAssayMethodProjectId(Long configAssayMethodProjectId) {
    	return selectList(new LambdaQueryWrapperX<ConfigAssayMethodProjectParameterDO>()
    			.eq(ConfigAssayMethodProjectParameterDO::getConfigAssayMethodProjectId, configAssayMethodProjectId));
    }
    
    default List<ConfigAssayMethodProjectParameterDO> selectByConfigAssayMethodProjectIds(List<Long> configAssayMethodProjectIds) {
    	return selectList(new LambdaQueryWrapperX<ConfigAssayMethodProjectParameterDO>()
    			.in(ConfigAssayMethodProjectParameterDO::getConfigAssayMethodProjectId, configAssayMethodProjectIds));
    }
    
    default List<ConfigAssayMethodProjectParameterDO> selectByConfigAssayMethodId(Long configAssayMethodId) {
    	return selectJoinList(ConfigAssayMethodProjectParameterDO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectParameterDO>()
    			.leftJoin(ConfigAssayMethodProjectDO.class, ConfigAssayMethodProjectDO::getId, ConfigAssayMethodProjectParameterDO::getConfigAssayMethodProjectId)
    			.selectAll(ConfigAssayMethodProjectParameterDO.class)
    			.eq(ConfigAssayMethodProjectDO::getConfigAssayMethodId, configAssayMethodId));
    }
    
    default List<ConfigAssayMethodProjectParameterDO> selectByConfigAssayMethodIds(List<Long> configAssayMethodIds) {
    	return selectJoinList(ConfigAssayMethodProjectParameterDO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectParameterDO>()
    			.leftJoin(ConfigAssayMethodProjectDO.class, ConfigAssayMethodProjectDO::getId, ConfigAssayMethodProjectParameterDO::getConfigAssayMethodProjectId)
    			.selectAll(ConfigAssayMethodProjectParameterDO.class)
    			.in(ConfigAssayMethodProjectDO::getConfigAssayMethodId, configAssayMethodIds));
    }

}